// get a random post from a subreddit prepared for reposting

// external modules
const url = require('url')

// internal modules
const r = require('./snoo')

const cache = {} // caching is important
function getSubreddit (name) {
  if (name in cache) return cache[name]

  return (cache[name] = r.getSubreddit(name))
}

function getRandomPost (subreddit = 'loljs') {
  return getSubreddit(subreddit).getRandomSubmission().then(function (post) {
    const selftext = url.parse(post.url).hostname === 'reddit.com'

    return {
      type: selftext ? 'text' : 'link',
      params: Object.assign({
        title: post.title
      }, selftext ? {text: post.selftext} : {url: post.url}),
      extra: {
        author: post.author,
        timestamp: post.created
      }
    }
  })
}

module.exports = getRandomPost
